#ifndef __PCAN_FIFO_H__
#define __PCAN_FIFO_H__

//****************************************************************************
// Copyright (C) 2001,2002,2003,2004  PEAK System-Technik GmbH
//
// linux@peak-system.com
// www.peak-system.com
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// Maintainer(s): Klaus Hitschler (klaus.hitschler@gmx.de)
//****************************************************************************

//****************************************************************************
//
// pcan_fifo.h - all about fifo buffer management
//
// $Log: pcan_fifo.h,v $
// Revision 1.10  2004/04/11 22:03:29  klaus
// cosmetic changes
//
// Revision 1.9  2003/03/02 10:58:07  klaus
// merged USB thread into main path
//
// Revision 1.8  2003/03/02 10:58:07  klaus
// merged USB thread into main path
//
// Revision 1.7.2.3  2003/01/29 20:34:20  klaus
// release_20030129_a and release_20030129_u released
//
// Revision 1.7.2.2  2003/01/29 20:34:20  klaus
// release_20030129_a and release_20030129_u released
//
// Revision 1.7.2.1  2003/01/28 23:28:26  klaus
// reorderd pcan_usb.c and pcan_usb_kernel.c, tidied up
//
// Revision 1.7  2002/01/30 20:54:27  klaus
// simple source file header change
//
//****************************************************************************

//****************************************************************************
// INCLUDES
#include <src/pcan_main.h>

//****************************************************************************
// DEFINES

//****************************************************************************
// PROTOTYPES
int pcan_fifo_reset(register FIFO_MANAGER *anchor);
int pcan_fifo_init(register FIFO_MANAGER *anchor, void *bufferBegin, void *bufferEnd, int nCount, u16 wCopySize);
int pcan_fifo_claim_for_put(register FIFO_MANAGER *anchor, void **pvPutData);
int pcan_fifo_put(register FIFO_MANAGER *anchor);
int pcan_fifo_put_reject(register FIFO_MANAGER *anchor);
int pcan_fifo_claim_for_get(register FIFO_MANAGER *anchor, void **pvGetData);
int pcan_fifo_get(register FIFO_MANAGER *anchor);
int pcan_fifo_get_reject(register FIFO_MANAGER *anchor);
int pcan_fifo_status(FIFO_MANAGER *anchor);
int pcan_fifo_near_full(FIFO_MANAGER *anchor);
int pcan_fifo_empty(FIFO_MANAGER *anchor);

#endif // __PCAN_FIFO_H__

